---
# BBOSS Copyright (C) 2018-2021, Laurent Marchelli
# SPDX-License-Identifier: GPL-3.0-or-later

# Requirements :
# Nexus service must be started and ready
# _nexus_api_task_list must contain the list of existing items

- name: "{{ nexus_title_prefix }}Create new {{ _nexus_api_title }}"
  ansible.builtin.uri:
    url: "{{ nexus_api_url + nexus_api_root + _nexus_api_path +
      _nexus_api_ext }}"
    use_proxy: no
    force_basic_auth: yes
    user: "{{ nexus_api_user }}"
    password: "{{ nexus_api_passwd }}"
    method: POST
    body_format: json
    body: >-
      {%- if _nexus_api_path == "script/" %}
        {{- {"name": item, "type": "groovy",
          "content": lookup("file", item + ".groovy")} }}
      {%- else %}
        {{- _nexus_api_item }}
      {%- endif %}
    status_code: [201, 204]
  # https://github.com/ansible/ansible/issues/58632
  # https://github.com/ansible/ansible/pull/65706
  environment:
    http_proxy: ''
    HTTP_PROXY: ''
    https_proxy: ''
    HTTPS_PROXYy: ''
    no_proxy: ''
    NO_PROXY: ''
  register: _nexus_api_task_new
  changed_when: _nexus_api_task_new.status in [201, 204]
  vars:
    _nexus_api_item: "{{ vars[_nexus_api_dict][item] }}"
    _nexus_api_ext: >-
      {%- if _nexus_api_path == "blobstores/" %}
        {{- "{}/".format(_nexus_api_item.type) }}
      {%- elif _nexus_api_path == "repositories/" %}
        {{- "{}/{}/".format(_nexus_api_item.format, _nexus_api_item.type) }}
      {%- endif %}
  when: item not in _nexus_api_task_list |
    community.general.json_query('json[*].name')
  loop: "{{ vars[_nexus_api_dict].keys() | sort }}"
